Index: c/src/lib/libbsp/i386/shared/irq/irq.c
===================================================================
--- c/src/lib/libbsp/i386/shared/irq/irq.c	(revision 711a2a113395e4801cf82adbcb70990e5eeddc65)
+++ c/src/lib/libbsp/i386/shared/irq/irq.c	(revision 0ebbf66b0ee518763ee38b4ac28c7d3b6feaadf1)
@@ -22,17 +22,17 @@
  * that must be disabled when a particular entry is activated.
  * They will be dynamically computed from teh prioruty table given
- * in pc386_rtems_irq_mngt_set();
+ * in BSP_rtems_irq_mngt_set();
  * CAUTION : this table is accessed directly by interrupt routine
  * 	     prologue.
  */
-rtems_i8259_masks 	irq_mask_or_tbl[PC_386_IRQ_LINES_NUMBER];
-
-/*
- * Copy of data given via initial pc386_rtems_irq_mngt_set() for
+rtems_i8259_masks 	irq_mask_or_tbl[BSP_IRQ_LINES_NUMBER];
+
+/*
+ * Copy of data given via initial BSP_rtems_irq_mngt_set() for
  * the sake of efficiency.
  * CAUTION : this table is accessed directly by interrupt routine
  * 	     prologue.
  */
-rtems_irq_hdl		current_irq[PC_386_IRQ_LINES_NUMBER];
+rtems_irq_hdl		current_irq[BSP_IRQ_LINES_NUMBER];
 /*
  * default handler connected on each irq after bsp initialization
@@ -57,5 +57,5 @@
 
 /*-------------------------------------------------------------------------+
-|         Function:  PC386_irq_disable_at_i8259s
+|         Function:  BSP_irq_disable_at_i8259s
 |      Description: Mask IRQ line in appropriate PIC chip.
 | Global Variables: i8259s_cache
@@ -63,11 +63,11 @@
 |          Returns: Nothing. 
 +--------------------------------------------------------------------------*/
-int pc386_irq_disable_at_i8259s    (const rtems_irq_symbolic_name irqLine)
+int BSP_irq_disable_at_i8259s    (const rtems_irq_symbolic_name irqLine)
 {
   unsigned short mask;
   unsigned int 	level;
 
-  if ( ((int)irqLine < PC_386_LOWEST_OFFSET) ||
-       ((int)irqLine > PC_386_MAX_OFFSET )
+  if ( ((int)irqLine < BSP_LOWEST_OFFSET) ||
+       ((int)irqLine > BSP_MAX_OFFSET )
        )
     return 1;
@@ -92,5 +92,5 @@
 
 /*-------------------------------------------------------------------------+
-|         Function:  pc386_irq_enable_at_i8259s
+|         Function:  BSP_irq_enable_at_i8259s
 |      Description: Unmask IRQ line in appropriate PIC chip.
 | Global Variables: i8259s_cache
@@ -98,11 +98,11 @@
 |          Returns: Nothing. 
 +--------------------------------------------------------------------------*/
-int pc386_irq_enable_at_i8259s    (const rtems_irq_symbolic_name irqLine)
+int BSP_irq_enable_at_i8259s    (const rtems_irq_symbolic_name irqLine)
 {
   unsigned short mask;
   unsigned int 	level;
 
-  if ( ((int)irqLine < PC_386_LOWEST_OFFSET) ||
-       ((int)irqLine > PC_386_MAX_OFFSET )
+  if ( ((int)irqLine < BSP_LOWEST_OFFSET) ||
+       ((int)irqLine > BSP_MAX_OFFSET )
        )
     return 1;
@@ -126,10 +126,10 @@
 } /* mask_irq */
 
-int pc386_irq_enabled_at_i8259s        	(const rtems_irq_symbolic_name irqLine)
+int BSP_irq_enabled_at_i8259s        	(const rtems_irq_symbolic_name irqLine)
 {
   unsigned short mask;
 
-  if ( ((int)irqLine < PC_386_LOWEST_OFFSET) ||
-       ((int)irqLine > PC_386_MAX_OFFSET )
+  if ( ((int)irqLine < BSP_LOWEST_OFFSET) ||
+       ((int)irqLine > BSP_MAX_OFFSET )
      )
     return 1;
@@ -141,5 +141,5 @@
 
 /*-------------------------------------------------------------------------+
-|         Function: pc386_irq_ack_at_i8259s
+|         Function: BSP_irq_ack_at_i8259s
 |      Description: Signal generic End Of Interrupt (EOI) to appropriate PIC.
 | Global Variables: None.
@@ -147,8 +147,8 @@
 |          Returns: Nothing. 
 +--------------------------------------------------------------------------*/
-int pc386_irq_ack_at_i8259s  	(const rtems_irq_symbolic_name irqLine)
-{
-  if ( ((int)irqLine < PC_386_LOWEST_OFFSET) ||
-       ((int)irqLine > PC_386_MAX_OFFSET )
+int BSP_irq_ack_at_i8259s  	(const rtems_irq_symbolic_name irqLine)
+{
+  if ( ((int)irqLine < BSP_LOWEST_OFFSET) ||
+       ((int)irqLine > BSP_MAX_OFFSET )
        )
     return 1;
@@ -213,5 +213,5 @@
 static int isValidInterrupt(int irq)
 {
-  if ( (irq < PC_386_LOWEST_OFFSET) || (irq > PC_386_MAX_OFFSET))
+  if ( (irq < BSP_LOWEST_OFFSET) || (irq > BSP_MAX_OFFSET))
     return 0;
   return 1;
@@ -222,5 +222,5 @@
  */
 
-int pc386_install_rtems_irq_handler  (const rtems_irq_connect_data* irq)
+int BSP_install_rtems_irq_handler  (const rtems_irq_connect_data* irq)
 {
     unsigned int level;
@@ -252,5 +252,5 @@
      * Enable interrupt at PIC level
      */
-    pc386_irq_enable_at_i8259s (irq->name);
+    BSP_irq_enable_at_i8259s (irq->name);
     /*
      * Enable interrupt on device
@@ -264,5 +264,5 @@
 
 
-int pc386_get_current_rtems_irq_handler	(rtems_irq_connect_data* irq)
+int BSP_get_current_rtems_irq_handler	(rtems_irq_connect_data* irq)
 {
      if (!isValidInterrupt(irq->name)) {
@@ -273,5 +273,5 @@
 }
 
-int pc386_remove_rtems_irq_handler  (const rtems_irq_connect_data* irq)
+int BSP_remove_rtems_irq_handler  (const rtems_irq_connect_data* irq)
 {
     unsigned int level;
@@ -295,5 +295,5 @@
      * disable interrupt at PIC level
      */
-    pc386_irq_disable_at_i8259s (irq->name);
+    BSP_irq_disable_at_i8259s (irq->name);
 
     /*
@@ -318,5 +318,5 @@
  */
 
-int pc386_rtems_irq_mngt_set(rtems_irq_global_settings* config)
+int BSP_rtems_irq_mngt_set(rtems_irq_global_settings* config)
 {
     int i;
@@ -338,10 +338,10 @@
     for (i=0; i < internal_config->irqNb; i++) {
       if (rtems_hdl_tbl[i].hdl != default_rtems_entry.hdl) {
-	pc386_irq_enable_at_i8259s (i);
+	BSP_irq_enable_at_i8259s (i);
 	rtems_hdl_tbl[i].on(&rtems_hdl_tbl[i]);
       }
       else {
 	rtems_hdl_tbl[i].off(&rtems_hdl_tbl[i]);
-	pc386_irq_disable_at_i8259s (i);
+	BSP_irq_disable_at_i8259s (i);
       }
     }
@@ -349,10 +349,10 @@
      * must disable slave pic anyway
      */
-    pc386_irq_enable_at_i8259s (2);
+    BSP_irq_enable_at_i8259s (2);
     _CPU_ISR_Enable(level);
     return 1;
 }
 
-int pc386_rtems_irq_mngt_get(rtems_irq_global_settings** config)
+int BSP_rtems_irq_mngt_get(rtems_irq_global_settings** config)
 {
     *config = internal_config;
Index: c/src/lib/libbsp/i386/shared/irq/irq.h
===================================================================
--- c/src/lib/libbsp/i386/shared/irq/irq.h	(revision 711a2a113395e4801cf82adbcb70990e5eeddc65)
+++ c/src/lib/libbsp/i386/shared/irq/irq.h	(revision 0ebbf66b0ee518763ee38b4ac28c7d3b6feaadf1)
@@ -38,25 +38,25 @@
 typedef enum {
     /* Base vector for our IRQ handlers. */
-  PC386_IRQ_VECTOR_BASE		=	PC386_ASM_IRQ_VECTOR_BASE,       
-  PC_386_IRQ_LINES_NUMBER    	= 	16,
-  PC_386_LOWEST_OFFSET		= 	0,
-  PC_386_MAX_OFFSET		= 	PC_386_IRQ_LINES_NUMBER - 1,
+  BSP_IRQ_VECTOR_BASE		=	BSP_ASM_IRQ_VECTOR_BASE,       
+  BSP_IRQ_LINES_NUMBER    	= 	16,
+  BSP_LOWEST_OFFSET		= 	0,
+  BSP_MAX_OFFSET		= 	BSP_IRQ_LINES_NUMBER - 1,
     /*
-     * Interrupt offset in comparison to PC386_ASM_IRQ_VECTOR_BASE
-     * NB : 1) Interrupt vector number in IDT = offset + PC386_ASM_IRQ_VECTOR_BASE
+     * Interrupt offset in comparison to BSP_ASM_IRQ_VECTOR_BASE
+     * NB : 1) Interrupt vector number in IDT = offset + BSP_ASM_IRQ_VECTOR_BASE
      * 	    2) The same name should be defined on all architecture
      *	       so that handler connexion can be unchanged.
      */	       
-  PC_386_PERIODIC_TIMER      	= 	0,
-
-  PC_386_KEYBOARD          	= 	1,
-
-  PC386_UART_COM2_IRQ		=	3,
-
-  PC386_UART_COM1_IRQ		=	4,
-
-  PC_386_RT_TIMER1	      	= 	8,
+  BSP_PERIODIC_TIMER      	= 	0,
+
+  BSP_KEYBOARD          	= 	1,
+
+  BSP_UART_COM2_IRQ		=	3,
+
+  BSP_UART_COM1_IRQ		=	4,
+
+  BSP_RT_TIMER1	      	= 	8,
   
-  PC_386_RT_TIMER3		= 	10
+  BSP_RT_TIMER3		= 	10
 }rtems_irq_symbolic_name;
 
@@ -128,5 +128,5 @@
   rtems_irq_connect_data*	irqHdlTbl;
   /*
-   * actual value of PC386_IRQ_VECTOR_BASE...
+   * actual value of BSP_IRQ_VECTOR_BASE...
    */
   rtems_irq_symbolic_name	irqBase;
@@ -156,5 +156,5 @@
  * not be propagated further to the processor
  */
-int pc386_irq_disable_at_i8259s        (const rtems_irq_symbolic_name irqLine);
+int BSP_irq_disable_at_i8259s        (const rtems_irq_symbolic_name irqLine);
 /*
  * function to enable a particular irq at 8259 level. After calling
@@ -162,5 +162,5 @@
  * be propagated further to the processor
  */
-int pc386_irq_enable_at_i8259s		(const rtems_irq_symbolic_name irqLine);
+int BSP_irq_enable_at_i8259s		(const rtems_irq_symbolic_name irqLine);
 /*
  * function to acknoledge a particular irq at 8259 level. After calling
@@ -170,9 +170,9 @@
  * handlers.
  */
-int pc386_irq_ack_at_i8259s           	(const rtems_irq_symbolic_name irqLine);
+int BSP_irq_ack_at_i8259s           	(const rtems_irq_symbolic_name irqLine);
 /*
  * function to check if a particular irq is enabled at 8259 level. After calling
  */
-int pc386_irq_enabled_at_i8259s        	(const rtems_irq_symbolic_name irqLine);
+int BSP_irq_enabled_at_i8259s        	(const rtems_irq_symbolic_name irqLine);
 /*
  * ------------------------ RTEMS Single Irq Handler Mngt Routines ----------------
@@ -212,10 +212,10 @@
  * 
  */
-int pc386_install_rtems_irq_handler   	(const rtems_irq_connect_data*);
+int BSP_install_rtems_irq_handler   	(const rtems_irq_connect_data*);
 /*
  * function to get the current RTEMS irq handler for ptr->name. It enables to
  * define hanlder chain...
  */
-int pc386_get_current_rtems_irq_handler	(rtems_irq_connect_data* ptr);
+int BSP_get_current_rtems_irq_handler	(rtems_irq_connect_data* ptr);
 /*
  * function to get disconnect the RTEMS irq handler for ptr->name.
@@ -223,5 +223,5 @@
  * The user can use the previous function to get it.
  */
-int pc386_remove_rtems_irq_handler    	(const rtems_irq_connect_data*);
+int BSP_remove_rtems_irq_handler    	(const rtems_irq_connect_data*);
 
 /*
@@ -234,8 +234,8 @@
  * handler (config->irqHdlTbl[i].hdl)  different from "config->defaultEntry.hdl"
  * has been individualy connected via
- *	pc386_install_rtems_irq_handler(&config->irqHdlTbl[i])
+ *	BSP_install_rtems_irq_handler(&config->irqHdlTbl[i])
  * And each handler currently equal to config->defaultEntry.hdl
  * has been previously disconnected via
- * 	 pc386_remove_rtems_irq_handler (&config->irqHdlTbl[i])
+ * 	 BSP_remove_rtems_irq_handler (&config->irqHdlTbl[i])
  *
  * This is to say that all information given will be used and not just
@@ -248,9 +248,9 @@
  */
 
-int pc386_rtems_irq_mngt_set(rtems_irq_global_settings* config);
+int BSP_rtems_irq_mngt_set(rtems_irq_global_settings* config);
 /*
  * (Re) get info on current RTEMS interrupt management.
  */
-int pc386_rtems_irq_mngt_get(rtems_irq_global_settings**);
+int BSP_rtems_irq_mngt_get(rtems_irq_global_settings**);
   
 #ifdef __cplusplus
Index: c/src/lib/libbsp/i386/shared/irq/irq_asm.h
===================================================================
--- c/src/lib/libbsp/i386/shared/irq/irq_asm.h	(revision 711a2a113395e4801cf82adbcb70990e5eeddc65)
+++ c/src/lib/libbsp/i386/shared/irq/irq_asm.h	(revision 0ebbf66b0ee518763ee38b4ac28c7d3b6feaadf1)
@@ -16,5 +16,5 @@
 #define __IRQ_ASM_H__
 
-#define PC386_ASM_IRQ_VECTOR_BASE 0x20
+#define BSP_ASM_IRQ_VECTOR_BASE 0x20
     /* PIC's command and mask registers */
 #define PIC_MASTER_COMMAND_IO_PORT		0x20	/* Master PIC command register */
Index: c/src/lib/libbsp/i386/shared/irq/irq_init.c
===================================================================
--- c/src/lib/libbsp/i386/shared/irq/irq_init.c	(revision 711a2a113395e4801cf82adbcb70990e5eeddc65)
+++ c/src/lib/libbsp/i386/shared/irq/irq_init.c	(revision 0ebbf66b0ee518763ee38b4ac28c7d3b6feaadf1)
@@ -56,7 +56,7 @@
  * Table used to store rtems managed interrupt handlers.
  * Borrow the table to store raw handler entries at the beginning.
- * The table will be reinitialized before the call to pc386_rtems_irq_mngt_set().
- */
-static rtems_irq_connect_data     	rtemsIrq[PC_386_IRQ_LINES_NUMBER] = {
+ * The table will be reinitialized before the call to BSP_rtems_irq_mngt_set().
+ */
+static rtems_irq_connect_data     	rtemsIrq[BSP_IRQ_LINES_NUMBER] = {
   {0,(rtems_irq_hdl)rtems_irq_prologue_0},
   {0,(rtems_irq_hdl)rtems_irq_prologue_1},
@@ -87,5 +87,5 @@
 };
 
-static rtems_irq_prio irqPrioTable[PC_386_IRQ_LINES_NUMBER]={
+static rtems_irq_prio irqPrioTable[BSP_IRQ_LINES_NUMBER]={
   /*
    * actual rpiorities for interrupt :
@@ -156,7 +156,7 @@
      * with RTEMS prologue.
      */
-    for (i = 0; i < PC_386_IRQ_LINES_NUMBER; i++) {
+    for (i = 0; i < BSP_IRQ_LINES_NUMBER; i++) {
       create_interrupt_gate_descriptor(&idtEntry,(rtems_raw_irq_hdl) rtemsIrq[i].hdl);
-      idt_entry_tbl[i + PC386_ASM_IRQ_VECTOR_BASE] = idtEntry;
+      idt_entry_tbl[i + BSP_ASM_IRQ_VECTOR_BASE] = idtEntry;
     }
     /*
@@ -168,5 +168,5 @@
      * re-init the rtemsIrq table
      */
-    for (i = 0; i < PC_386_IRQ_LINES_NUMBER; i++) {
+    for (i = 0; i < BSP_IRQ_LINES_NUMBER; i++) {
       rtemsIrq[i]      = defaultIrq;
       rtemsIrq[i].name = i;
@@ -175,11 +175,11 @@
      * Init initial Interrupt management config
      */
-    initial_config.irqNb 	= PC_386_IRQ_LINES_NUMBER;
+    initial_config.irqNb 	= BSP_IRQ_LINES_NUMBER;
     initial_config.defaultEntry = defaultIrq;
     initial_config.irqHdlTbl	= rtemsIrq;
-    initial_config.irqBase	= PC386_ASM_IRQ_VECTOR_BASE;
+    initial_config.irqBase	= BSP_ASM_IRQ_VECTOR_BASE;
     initial_config.irqPrioTbl	= irqPrioTable;
 
-    if (!pc386_rtems_irq_mngt_set(&initial_config)) {
+    if (!BSP_rtems_irq_mngt_set(&initial_config)) {
       /*
        * put something here that will show the failure...
@@ -201,5 +201,5 @@
       printk("idt_entry_tbl =  %x Interrupt_descriptor_table addr = %x\n",
 	     idt_entry_tbl, &Interrupt_descriptor_table);
-      tmp = (unsigned) get_hdl_from_vector (PC386_ASM_IRQ_VECTOR_BASE + PC_386_PERIODIC_TIMER);
+      tmp = (unsigned) get_hdl_from_vector (BSP_ASM_IRQ_VECTOR_BASE + BSP_PERIODIC_TIMER);
       printk("clock isr address from idt = %x should be %x\n",
 	     tmp, (unsigned) rtems_irq_prologue_0);
Index: c/src/lib/libbsp/i386/shared/pci/pcibios.c
===================================================================
--- c/src/lib/libbsp/i386/shared/pci/pcibios.c	(revision 0ebbf66b0ee518763ee38b4ac28c7d3b6feaadf1)
+++ c/src/lib/libbsp/i386/shared/pci/pcibios.c	(revision 0ebbf66b0ee518763ee38b4ac28c7d3b6feaadf1)
@@ -0,0 +1,499 @@
+/*
+ * This software is Copyright (C) 1998 by T.sqware - all rights limited
+ * It is provided in to the public domain "as is", can be freely modified
+ * as far as this copyight notice is kept unchanged, but does not imply
+ * an endorsement by T.sqware of the product in which it is included.
+ *
+ *  $Id$
+ */
+
+#include <rtems.h>
+#include <bsp.h>
+#include <assert.h>
+#include <pcibios.h>
+
+/*
+ * This is simpliest possible PCI BIOS, it assumes that addressing
+ * is flat and that stack is big enough 
+ */ 
+
+
+static int pcibInitialized = 0;
+static unsigned int pcibEntry;
+
+/*
+ * Array to pass data between c and asm parts, at the time of 
+ * writing I am not yet that familiar with extended asm feature 
+ * of gcc. This code is not on performance path, so we can care 
+ * relatively little about performance here 
+ */
+static volatile unsigned int pcibExchg[5];
+
+static int pcib_convert_err(int err);
+
+/*
+ * Detects presense of PCI BIOS, returns 
+ * error code
+ */
+int 
+pcib_init(void)
+{
+  unsigned char *ucp;
+  unsigned char sum;
+  int      i;
+
+  pcibInitialized = 0;
+
+  /* First, we have to look for BIOS-32 */
+  for(ucp=(unsigned char *)0xE0000; ucp < (unsigned char *)0xFFFFF; ucp+=0x10)
+    {
+      if(memcmp(ucp, "_32_", 4) != 0)
+	{
+	  continue;
+	}
+
+      /* Got signature, check length  */
+      if(*(ucp + 9) != 1)
+	{
+	  continue;
+	}
+
+      /* Verify checksum */
+      sum = 0;
+      for(i=0; i<16; i++)
+	{
+	  sum += *(ucp+i);
+	}
+
+      if(sum == 0)
+	{
+	  /* found */
+	  break;
+	}
+    }
+
+  if(ucp >= (unsigned char *)0xFFFFF)
+    {
+      /* BIOS-32 not found */
+      assert(0);
+      return PCIB_ERR_NOTPRESENT;
+    }
+
+  /* BIOS-32 found, let us find PCI BIOS */
+  ucp += 4;
+
+  pcibExchg[0] = *(unsigned int *)ucp;
+
+  asm ("    pusha");                  /* Push all registers */  
+  asm ("    movl pcibExchg, %edi");   /* Move entry point to esi */
+  asm ("    movl $0x49435024, %eax"); /* Move signature to eax */
+  asm ("    xorl %ebx, %ebx");        /* Zero ebx */
+  asm ("    pushl %cs");
+  asm ("    call *%edi");             /* Call entry */
+  asm ("    movl %eax, pcibExchg");
+  asm ("    movl %ebx, pcibExchg+4");
+  asm ("    movl %ecx, pcibExchg+8");
+  asm ("    movl %edx, pcibExchg+12");
+  asm ("    popa");
+
+  if((pcibExchg[0] & 0xff) != 0)
+    {
+      /* Not found */
+      assert(0);
+      return PCIB_ERR_NOTPRESENT;
+    }
+
+  /* Found PCI entry point */
+  pcibEntry = pcibExchg[1] + pcibExchg[3];
+
+  /* Let us check whether PCI bios is present */
+  pcibExchg[0] = pcibEntry;
+  
+  asm("    pusha");
+  asm("    movl pcibExchg, %edi");
+  asm("    movb $0xb1, %ah");
+  asm("    movb $0x01, %al");
+  asm ("   pushl %cs");
+  asm("    call *%edi");
+  asm("    movl %eax, pcibExchg");
+  asm("    movl %ebx, pcibExchg+4");
+  asm("    movl %ecx, pcibExchg+8");
+  asm("    movl %edx, pcibExchg+12");
+  asm("    popa");
+
+  if((pcibExchg[0] & 0xff00) != 0)
+    {
+      /* Not found */
+      assert(0);
+      return PCIB_ERR_NOTPRESENT;
+    }
+
+  if(pcibExchg[3] != 0x20494350)
+    {
+      /* Signature does not match */
+      assert(0);
+      return PCIB_ERR_NOTPRESENT;
+    }
+
+  /* Success */
+  
+  pcibInitialized = 1;
+  return PCIB_ERR_SUCCESS;
+}
+
+/* 
+ * Find specified device and return its signature: combination 
+ * of bus number, device number and function number
+ */
+int
+pcib_find_by_devid(int vendorId, int devId, int idx, int *sig)
+{
+  if(!pcibInitialized)
+    {
+      assert(0);
+      return PCIB_ERR_UNINITIALIZED;
+    }
+
+  pcibExchg[0] = pcibEntry;
+  pcibExchg[1] = vendorId;
+  pcibExchg[2] = devId;
+  pcibExchg[3] = idx;
+
+  asm("    pusha");
+  asm("    movl pcibExchg, %edi");
+  asm("    movb $0xb1, %ah");
+  asm("    movb $0x02, %al");
+  asm("    movl pcibExchg+4, %edx");
+  asm("    movl pcibExchg+8, %ecx");
+  asm("    movl pcibExchg+12, %esi");
+  asm("    pushl %cs");
+  asm("    call *%edi");
+  asm("    movl %eax, pcibExchg");
+  asm("    movl %ebx, pcibExchg+4");
+  asm("    popa");
+
+  *sig = pcibExchg[1] & 0xffff;
+
+  return pcib_convert_err((pcibExchg[0] >> 8) & 0xff);
+}
+
+/* 
+ * Find specified class code return device signature: combination 
+ * of bus number, device number and function number
+ */
+int
+pcib_find_by_class(int classCode, int idx, int *sig)
+{
+  if(!pcibInitialized)
+    {
+      assert(0);
+      return PCIB_ERR_UNINITIALIZED;
+    }
+
+  pcibExchg[0] = pcibEntry;
+  pcibExchg[1] = classCode;
+  pcibExchg[2] = idx;
+
+  asm("    pusha");
+  asm("    movl pcibExchg, %edi");
+  asm("    movb $0xb1, %ah");
+  asm("    movb $0x03, %al");
+  asm("    movl pcibExchg+4, %ecx");
+  asm("    movl pcibExchg+8, %esi");
+  asm("    pushl %cs");
+  asm("    call *%edi");
+  asm("    movl %eax, pcibExchg");
+  asm("    movl %ebx, pcibExchg+4");
+  asm("    popa");
+
+  if((pcibExchg[0] & 0xff00) != 0)
+    {
+      return pcib_convert_err((pcibExchg[0] >> 8) & 0xff);
+    }
+
+  *sig = pcibExchg[1] & 0xffff;
+
+  return PCIB_ERR_SUCCESS;
+}
+  
+  
+
+/* 
+ * Generate Special Cycle
+ */
+int
+pcib_special_cycle(int busNo, int data)
+{
+  if(!pcibInitialized)
+    {
+      assert(0);
+      return PCIB_ERR_UNINITIALIZED;
+    }
+
+  pcibExchg[0] = pcibEntry;
+  pcibExchg[1] = busNo << 8;
+  pcibExchg[2] = data;
+
+  asm("    pusha");
+  asm("    movl pcibExchg, %edi");
+  asm("    movb $0xb1, %ah");
+  asm("    movb $0x06, %al");
+  asm("    movl pcibExchg+4, %ebx");
+  asm("    movl pcibExchg+8, %edx");
+  asm("    pushl %cs");
+  asm("    call *%edi");
+  asm("    movl %eax, pcibExchg");
+  asm("    movl %ebx, pcibExchg+4");
+  asm("    popa");
+
+  return pcib_convert_err((pcibExchg[0] >> 8) & 0xff);
+}
+  
+
+/* 
+ * Read byte from config space
+ */
+int
+pcib_conf_read8(int sig, int off, unsigned char *data)
+{
+  if(!pcibInitialized)
+    {
+      assert(0);
+      return PCIB_ERR_UNINITIALIZED;
+    }
+
+  pcibExchg[0] = pcibEntry;
+  pcibExchg[1] = sig;
+  pcibExchg[2] = off;
+
+  asm("    pusha");
+  asm("    movl pcibExchg, %esi");
+  asm("    movb $0xb1, %ah");
+  asm("    movb $0x08, %al");
+  asm("    movl pcibExchg+4, %ebx");
+  asm("    movl pcibExchg+8, %edi");
+  asm("    pushl %cs");
+  asm("    call *%esi");
+  asm("    movl %eax, pcibExchg");
+  asm("    movl %ecx, pcibExchg+4");
+  asm("    popa");
+
+  if((pcibExchg[0] & 0xff00) != 0)
+    {
+      return pcib_convert_err((pcibExchg[0] >> 8) & 0xff);
+    }
+
+  *data = (unsigned char)pcibExchg[1] & 0xff;
+
+  return PCIB_ERR_SUCCESS;
+}
+  
+
+/* 
+ * Read word from config space
+ */
+int
+pcib_conf_read16(int sig, int off, unsigned short *data)
+{
+  if(!pcibInitialized)
+    {
+      assert(0);
+      return PCIB_ERR_UNINITIALIZED;
+    }
+
+  pcibExchg[0] = pcibEntry;
+  pcibExchg[1] = sig;
+  pcibExchg[2] = off;
+
+  asm("    pusha");
+  asm("    movl pcibExchg, %esi");
+  asm("    movb $0xb1, %ah");
+  asm("    movb $0x09, %al");
+  asm("    movl pcibExchg+4, %ebx");
+  asm("    movl pcibExchg+8, %edi");
+  asm("    pushl %cs");
+  asm("    call *%esi");
+  asm("    movl %eax, pcibExchg");
+  asm("    movl %ecx, pcibExchg+4");
+  asm("    popa");
+
+  if((pcibExchg[0] & 0xff00) != 0)
+    {
+      return pcib_convert_err((pcibExchg[0] >> 8) & 0xff);
+    }
+
+  *data = (unsigned short)pcibExchg[1] & 0xffff;
+
+  return PCIB_ERR_SUCCESS;
+}
+  
+
+/* 
+ * Read dword from config space
+ */
+int
+pcib_conf_read32(int sig, int off, unsigned int *data)
+{
+  if(!pcibInitialized)
+    {
+      assert(0);
+      return PCIB_ERR_UNINITIALIZED;
+    }
+
+  pcibExchg[0] = pcibEntry;
+  pcibExchg[1] = sig;
+  pcibExchg[2] = off;
+
+  asm("    pusha");
+  asm("    movl pcibExchg, %esi");
+  asm("    movb $0xb1, %ah");
+  asm("    movb $0x0a, %al");
+  asm("    movl pcibExchg+4, %ebx");
+  asm("    movl pcibExchg+8, %edi");
+  asm("    pushl %cs");
+  asm("    call *%esi");
+  asm("    movl %eax, pcibExchg");
+  asm("    movl %ecx, pcibExchg+4");
+  asm("    popa");
+
+  if((pcibExchg[0] & 0xff00) != 0)
+    {
+      return pcib_convert_err((pcibExchg[0] >> 8) & 0xff);
+    }
+
+  *data = (unsigned int)pcibExchg[1];
+
+  return PCIB_ERR_SUCCESS;
+}
+  
+
+/* 
+ * Write byte into  config space
+ */
+int
+pcib_conf_write8(int sig, int off, unsigned int data)
+{
+  if(!pcibInitialized)
+    {
+      assert(0);
+      return PCIB_ERR_UNINITIALIZED;
+    }
+
+  pcibExchg[0] = pcibEntry;
+  pcibExchg[1] = sig;
+  pcibExchg[2] = off;
+  pcibExchg[3] = data & 0xff;
+
+  asm("    pusha");
+  asm("    movl pcibExchg, %esi");
+  asm("    movb $0xb1, %ah");
+  asm("    movb $0x0b, %al");
+  asm("    movl pcibExchg+4, %ebx");
+  asm("    movl pcibExchg+8, %edi");
+  asm("    movl pcibExchg+12, %ecx");
+  asm("    pushl %cs");
+  asm("    call *%esi");
+  asm("    movl %eax, pcibExchg");
+  asm("    popa");
+
+  return pcib_convert_err((pcibExchg[0] >> 8) & 0xff);
+}
+
+/* 
+ * Write word into config space
+ */
+int
+pcib_conf_write16(int sig, int off, unsigned int data)
+{
+  if(!pcibInitialized)
+    {
+      assert(0);
+      return PCIB_ERR_UNINITIALIZED;
+    }
+
+  pcibExchg[0] = pcibEntry;
+  pcibExchg[1] = sig;
+  pcibExchg[2] = off;
+  pcibExchg[3] = data & 0xffff;
+
+  asm("    pusha");
+  asm("    movl pcibExchg, %esi");
+  asm("    movb $0xb1, %ah");
+  asm("    movb $0x0c, %al");
+  asm("    movl pcibExchg+4, %ebx");
+  asm("    movl pcibExchg+8, %edi");
+  asm("    movl pcibExchg+12, %ecx");
+  asm("    pushl %cs");
+  asm("    call *%esi");
+  asm("    movl %eax, pcibExchg");
+  asm("    popa");
+
+  return pcib_convert_err((pcibExchg[0] >> 8) & 0xff);
+}
+  
+
+
+/* 
+ * Write dword into config space
+ */
+int
+pcib_conf_write32(int sig, int off, unsigned int data)
+{
+  if(!pcibInitialized)
+    {
+      assert(0);
+      return PCIB_ERR_UNINITIALIZED;
+    }
+
+  pcibExchg[0] = pcibEntry;
+  pcibExchg[1] = sig;
+  pcibExchg[2] = off;
+  pcibExchg[3] = data;
+
+  asm("    pusha");
+  asm("    movl pcibExchg, %esi");
+  asm("    movb $0xb1, %ah");
+  asm("    movb $0x0d, %al");
+  asm("    movl pcibExchg+4, %ebx");
+  asm("    movl pcibExchg+8, %edi");
+  asm("    movl pcibExchg+12, %ecx");
+  asm("    pushl %cs");
+  asm("    call *%esi");
+  asm("    movl %eax, pcibExchg");
+  asm("    popa");
+
+  return pcib_convert_err((pcibExchg[0] >> 8) & 0xff);
+}
+  
+
+static int
+pcib_convert_err(int err)
+{
+  switch(err & 0xff)
+    {
+    case 0:
+      return PCIB_ERR_SUCCESS;
+    case 0x81:
+      return PCIB_ERR_NOFUNC;
+    case 0x83:
+      return PCIB_ERR_BADVENDOR;
+    case 0x86:
+      return PCIB_ERR_DEVNOTFOUND;
+    case 0x87:
+      return PCIB_ERR_BADREG;
+    default:
+      assert(0);
+      break;
+    }
+  return PCIB_ERR_NOFUNC;
+}
+	
+      
+
+
+  
+      
+  
+
+
+
Index: c/src/lib/libbsp/i386/shared/pci/pcibios.h
===================================================================
--- c/src/lib/libbsp/i386/shared/pci/pcibios.h	(revision 0ebbf66b0ee518763ee38b4ac28c7d3b6feaadf1)
+++ c/src/lib/libbsp/i386/shared/pci/pcibios.h	(revision 0ebbf66b0ee518763ee38b4ac28c7d3b6feaadf1)
@@ -0,0 +1,46 @@
+/*
+ * This software is Copyright (C) 1998 by T.sqware - all rights limited
+ * It is provided in to the public domain "as is", can be freely modified
+ * as far as this copyight notice is kept unchanged, but does not imply
+ * an endorsement by T.sqware of the product in which it is included.
+ */
+
+#ifndef _PCIB_H
+#define _PCIB_H
+
+/* Error codes */
+#define PCIB_ERR_SUCCESS       (0)
+#define PCIB_ERR_UNINITIALIZED (-1)  /* PCI BIOS is not initilized */
+#define PCIB_ERR_NOTPRESENT    (-2)  /* PCI BIOS not present */
+#define PCIB_ERR_NOFUNC        (-3)  /* Function not supported */
+#define PCIB_ERR_BADVENDOR     (-4)  /* Bad Vendor ID */
+#define PCIB_ERR_DEVNOTFOUND   (-5)  /* Device not found */
+#define PCIB_ERR_BADREG        (-6)  /* Bad register number */   
+
+/* 
+ * Make device signature from bus number, device numebr and function 
+ * number
+ */
+#define PCIB_DEVSIG_MAKE(b,d,f) ((b<<8)|(d<<3)|(f))
+
+/*
+ * Extract valrous part from device signature
+ */
+#define PCIB_DEVSIG_BUS(x) (((x)>>8) &0xff)
+#define PCIB_DEVSIG_DEV(x) (((x)>>3) & 0x1f)
+#define PCIB_DEVSIG_FUNC(x) ((x) & 0x7)
+
+int pcib_init(void);
+int pcib_find_by_devid(int vendorId, int devId, int idx, int *sig);
+int pcib_find_by_class(int classCode, int idx, int *sig);
+int pcib_special_cycle(int busNo, int data);
+int pcib_conf_read8(int sig, int off, unsigned char *data);
+int pcib_conf_read16(int sig, int off, unsigned short *data);
+int pcib_conf_read32(int sig, int off, unsigned int *data);
+int pcib_conf_write8(int sig, int off, unsigned int data);
+int pcib_conf_write16(int sig, int off, unsigned int data);
+int pcib_conf_write32(int sig, int off, unsigned int data);
+
+
+#endif /* _PCIB_H */
+
